/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/

#include <libc.h>
#include <stdio.h>

#include "oo7.h"
#include "globals.h"
#include "GenParams.h"
#include "BenchParams.h"
#include "VarParams.h"
#include "IntBtree.h"

//////////////////////////////////////////////////////////////////
//
// Query #1 - randomly choose "Query1RepeatCnt" atomic parts by 
// lookup on their id field.  An index can be used for the
// actual lookup.  
//
/////////////////////////////////////////////////////////////////


extern int	debugMode;

//////////////////////////////////////////////////////////////////
//
// Routine to do Query #1
//
//////////////////////////////////////////////////////////////////


int query1()
{
    int partId;
    AtomicPart* atomH;

    // set random seed so "hot" runs are truly hot
    srandom(1);

    // now randomly select parts via partId index and process them
    for (int i = 0; i < Query1RepeatCnt; i++) {

	// generate part id and lookup part
	partId = (int) (random() % TotalAtomicParts) + 1;
	atomH = (AtomicPart*) AtomicPartIdx->lookup(partId);
	if (atomH == NULL) {
            fprintf(stderr, "ERROR: Unable to find atomic part %d\n", partId);
/*
	    E_AbortTransaction();
            exit(1);
*/
        }
	else
	{
          if (debugMode) {
            printf("    In Query1, partId = %d:\n", partId);
          }
	  // process part by calling the null procedure
          atomH->DoNothing();
	}
    }
    return Query1RepeatCnt;
}
