/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/

// collection to hold composite parts  and connections
extern persistent collection <dbvoid> CompPartSet;

// collection for atomic parts, no longer allocated from CompPartSet
extern persistent collection <AtomicPart> AtomicPartSet;

// collection to hold documents
extern persistent collection <dbvoid> DocumentSet;

// collection to hold manuals
extern persistent collection <Manual> ManualSet;

// collection to hold modules and their assemblies
extern persistent collection <dbvoid> ModuleSet;

// index mapping atomic part ids to atomic parts
extern persistent dbclass IntBtIndex*  AtomicPartIdx; 

// index mapping composite part ids to composite parts
extern persistent dbclass IntBtIndex*  CompPartIdx; 

// index mapping document titles to documents
extern persistent dbclass StringBtIndex*  DocumentIdx; 

// index mapping document ids to documents
extern persistent dbclass IntBtIndex*  DocumentIdIdx;

// index mapping assembly ids to base assemblies
extern persistent dbclass IntBtIndex*  BaseAssemblyIdx; 

// index mapping module names to modules
extern persistent dbclass StringBtIndex*  ModuleIdx;

// AllModules is an extent of all modules
extern persistent dbclass Assoc  AllModules;

// AllDocuments is an extent of all documents
extern persistent dbclass Assoc  AllDocuments;

// AllCompParts is an extent of all composite parts
extern persistent dbclass Assoc  AllCompParts;

// DummySet is an extent used to hold dummy objects
extern persistent collection<dbvoid> DummySetCol;
extern persistent dbclass Assoc DummySet;
